###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
# Copyright (c) 2006 Mehdi Abaakouk
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import os
import urllib
import urlparse
import gtkhtml2
import config

opener = urllib.FancyURLopener()
opener.addheaders.pop(0)
opener.addheader("User-Agent","Mozilla")


def get_template():
    font = "Sans"
    size = "10"
    full_font = config.get("setting","web_font")
    try : font = full_font [:full_font.rindex(" ")]
    except:size
    try : size = full_font [full_font.rindex(" ")+1:]
    except:pass
    return """
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                <style>*{
                         font-size:11px;
                        }
                        a{color:#A69F91}
                        a:hover{color:blue}
                       body{
                         margin:0px;
                         padding:7px;
                         font-family: "%s";
                         font-size:%spx;
                         background-color:white;
                        }
                        p,ul,li,form,blockquote,dt,dd,a,b,i,u,div,span,h1,h2,h3,h4,h5,h6{
                           font-family: "%s";
                           font-size:%spx;
                        }
                        h1{font-size:1.6em;font-weight:bold;}
                        h2{font-size:1.4em;font-weight:bold;}
                        h3{font-size:1.2em;}
                        h4{font-size:1.1em;}
                        h5{font-size:1.0em;}
                        h6{font-size:0.8em;}
                        img{border:0px;}
                </style>
                </head>
            <body>
            <img style="float:right;margin-top:30px;margin-right:10px;" src="file://%s/bg_listen.png">
            %s
            </div>
            </body>
        </html>
                """%(font,size,font,size,config.PIXMAP_DIR,"%s")

class HTMLDocument(gtkhtml2.Document):

    def __init__(self):
        gtkhtml2.Document.__init__(self)
        self.connect('request_url', self.request_url)
        self.base_uri=''


    def set_base_uri(self,base_uri):
        self.base_uri=base_uri

    def is_relative_to_server(self,url):
        parts = urlparse.urlparse(url)
        if parts[0] or parts[1]:
            return 0
        return 1

    def open_url(self,url,try_base_uri=True):
        #uri = self.resolve_uri(url)
        try:f = opener.open(url)
        except:
            if try_base_uri and url.rfind(self.base_uri)==-1:
                #print "link not found : ",url
                #print "try :"+self.base_uri+url
                return self.open_url(self.base_uri+url,False)
            else:
                #print "link not found : ",url
                return None
        return f

    def resolve_uri(self,uri):
        if self.is_relative_to_server(uri):
            return urlparse.urljoin(self.current_url, uri)
        return uri

    def nothing(self,stream,data):
        #print "nothing",stream,data
        pass

    def request_url(self,document, url, stream,try_base_uri=True):
        stream.set_cancel_func(self.nothing)
        try: f = self.open_url(url)
        except:
            if try_base_uri:
                return self.request_url(document, self.base_uri+url, stream,False)
            else:
                print "not found : ",url
                return
        else:
            if f != None:
                stream.write(f.read())
            else:
                print "not found : ",url
                return
